/*
------------------------------------
|      Skalbimo masinu nuoma       |
|              main.cpp            |
------------------------------------

Autorius: Ignas Taraskevicius 3gr. IT 1 kursas
*/
#include <iostream>
#include <iomanip>
#include <vector>
#include <climits>
using namespace std;
//------------------------------------------------------------
struct Machine
{
  //  string   name;
    int      nr;
    string   type;         // "S - skalbykle", "D - dziovintuvas"
    int      size;         // "KG"
    double   hPrice;       // 1 hour price
    int      hRented;      //kiek valandu nuomuojam
    int      timesRented;  // isnuomavimo kartu kiekis
    double   moneyEarned;  //kiek pinigu uzdirbo masina
    int      rentedByCustomer;  // numeruosime nuo 1
};
typedef vector<Machine> Machines;
//------------------------------------------------------------
struct Customer
{
    string   name;          //vardas, pavarde
    string   id;           //asmens kodas
    string   address;     //adresas
    double   moneySpend; // isleisti pinigai
};
typedef vector<Customer> Customers;
//------------------------------------------------------------
void printMachines    (const Machines&     machines);
void printCustomers   (const Customers&    customers);
void addMachine       (      Machines&     machines);
void addCustomer      (      Customers&    customers);
void rentMachine      (      Machines&     machines, Customers& customers);
void returnMachine    (      Machines&     machines);
void freeMachine      (const Machines&     machines);
void bookedMachine    (const Machines&     machines);
//------------------------------------------------------------
void printMenu ()
{
    cout << endl
         << "Skalbimo masinu nuoma:" << endl
         << "  1 - spausdinti skalbimo masinas"     << endl
         << "  2 - prideti nauja skalbima masina"   << endl
         << "  3 - isnuomuoti klientui"             << endl
         << "  4 - grazinti skalbimo masina"        << endl
         << "  5 - neisnuomuotu masinu sarasas"     << endl
         << "  6 - isnuomuotu masinu sarasas"       << endl
         << endl
         << "  7 - spausdinti klientus"   << endl
         << "  8 - prideti nauja klienta" << endl
         << endl
         << "  0 - pabaikim darba mielieji draugai ir isgerkim"   << endl;
}
//------------------------------------------------------------
int main ()
{
    Machines     machines;
    Customers    customers;

    for (;;)
    {
        cout << "\n----------------------------------------\n";
        cout << "(m - rodyti meniu) > ";
        string key;
        cin >> key;
             if (key == "0") return 0;
        else if (key == "m") printMenu        ();
        else if (key == "1") printMachines    (machines);
        else if (key == "2") addMachine       (machines);
        else if (key == "3") rentMachine      (machines, customers);
        else if (key == "4") returnMachine    (machines);
        else if (key == "5") freeMachine      (machines);
        else if (key == "6") bookedMachine    (machines);
        else if (key == "7") printCustomers   (customers);
        else if (key == "8") addCustomer      (customers);
        else cout << endl << "Neteisinga komanda..." << endl;
    }

}
//------------------------------------------------------------
void freeMachine      (const Machines&    machines)
{
    cout << "Neisnuomuotu skalbimo masinu sarasas " << endl;
    for (unsigned int i = 0; i < machines.size(); i++)
    {
        if (machines[i].rentedByCustomer == 0)
        {
         cout << (i+1)
             << ". "  << machines[i].nr
             << "\t"  << machines[i].type
             << " "   << machines[i].size << "Kg"
             << "\t(" << machines[i].hPrice << "Lt)"
             << "\t"  << machines[i].hRented << "h"
             << "\t"  << machines[i].timesRented
             << "\t"  << machines[i].moneyEarned
             << endl;
        }
    }
}
//------------------------------------------------------------
void bookedMachine    (const Machines&    machines)
{
    cout << "Isnuomuotu skalbimo masinu sarasas " << endl;
    for (unsigned int i = 0; i < machines.size(); i++)
    {
        if (machines[i].rentedByCustomer != 0)
        {
         cout << (i+1)
             << ". "  << machines[i].nr
             << "\t"  << machines[i].type
             << " "   << machines[i].size << "Kg"
             << "\t(" << machines[i].hPrice << "Lt)"
             << "\t"  << machines[i].hRented << "h"
             << "\t"  << machines[i].timesRented
             << "\t"  << machines[i].moneyEarned
             << endl;
        }
    }
}
//------------------------------------------------------------
void printMachines    (const Machines&    machines)
{
    cout << "Skalbimo masinu kiekis: " << machines.size() << endl;
    for (unsigned int i = 0;  i < machines.size();  i++)
    {
        cout << (i+1)
             << ". "  << machines[i].nr
             << "\t"  << machines[i].type
             << " "   << machines[i].size << "Kg"
             << "\t(" << machines[i].hPrice << "Lt)"
             << "\t"  << machines[i].hRented << "h"
             << "\t"  << machines[i].timesRented
             << "\t"  << machines[i].moneyEarned
             << "\t"  << machines[i].rentedByCustomer
             << endl;
    }
}
//------------------------------------------------------------
void printCustomers (const Customers& customers)
{
    cout << "Klietu kiekis: " << customers.size() << endl;
    for (unsigned int i = 0;  i < customers.size();  i++)
    {
        cout << (i+1)
             << ". (" << customers[i].moneySpend << "Lt)"
             << "\t"  << customers[i].name
             << "\t"  << customers[i].id
             << " ("  << customers[i].address << ")"
             << endl;
    }
}
//------------------------------------------------------------
void addMachine (Machines& machines)
{
    cin.ignore(INT_MAX, '\n'); // ignoruojam uzsilikusi klaviaturos ENTER
    Machine machine;
    cout << "Iveskite naujos skalbimo masinos duomenis:" << endl;
    cout << "    skalbimo masinos numeris           : "; cin >> machine.nr; //getline(cin, machine.id);
    cout << "    tipas(S-skalbykle, D-dziovintuvas) : ";  cin >> machine.type;
    cout << "    Talpa (Kg)                         : ";  cin >> machine.size;
    cout << "    kaina 1 valandai                   : ";  cin >> machine.hPrice;
    machine.rentedByCustomer =  0;
    machine.moneyEarned      =  0;
    machine.timesRented      =  0;
    machine.hRented          =  0;
    machines.push_back(machine);
}
//------------------------------------------------------------
void addCustomer (Customers& customers)
{
    cin.ignore(INT_MAX, '\n'); // ignoruojam uzsilikusi klaviaturos ENTER
    Customer customer;
    cout << "Iveskite nauja klienta:" << endl;
    cout << "    vardas       : ";  getline(cin, customer.name);
    cout << "    asmens kodas : ";  getline(cin, customer.id);
    cout << "    adresas      : ";  getline(cin, customer.address);
    customer.moneySpend = 0;
    customers.push_back(customer);
}
//------------------------------------------------------------
void rentMachine (Machines& machines, Customers& customers)
{
     int machineNo = 0;
     printMachines (machines);
     cout << "Iveskit skalbimo masinos eiles numeri: ";
     cin  >> machineNo;
     if (machineNo <= 0  ||  machineNo > machines.size())
     {
         cout << "KLAIDA: nera skalbimo masinos su ivestu eiles numeriu.";
         return;
     }
     if (machines[machineNo-1].rentedByCustomer != 0)
     {
         cout << "KLAIDA: skalbimo masina jau yra isnuomota.";
         return;
     }

     int customerNo = 0;
     printCustomers (customers);
     cout << "Pasirinkite kliento eiles numeri: ";
     cin  >> customerNo;
     if (customerNo <= 0  ||  customerNo > customers.size())
     {
         cout << "KLAIDA: nera kliento su ivestu eiles numeriu.";
         return;
     }

     int hourCount;
     cout << "Kelioms valandoms nuomuosime        : ";
     cin  >> hourCount;
     machines[machineNo-1].rentedByCustomer   = customerNo;
     machines[machineNo-1].moneyEarned       += hourCount * machines[machineNo-1].hPrice;
     machines[machineNo-1].timesRented += 1;
     customers[customerNo-1].moneySpend += hourCount * machines[machineNo-1].hPrice;
}
//------------------------------------------------------------
void returnMachine    (Machines&     machines)
{
     int machineNo = 0;
     printMachines (machines);
     cout << "Iveskit skalbimo masinos eiles numeri: ";
     cin  >> machineNo;
     if (machineNo <= 0  ||  machineNo > machines.size())
     {
         cout << "KLAIDA: nera skalbimo masinos su ivestu eiles numeriu.";
         return;
     }
     machines[machineNo-1].rentedByCustomer = 0;
}
//============================================================
